import 'reflect-metadata';
import { StaticModelT, ModelT, PkType } from '../core';
import { Server } from '../server';
import { Logger } from '../services';
export declare class OrmReflector {
    private server;
    constructor(server: Server);
    readonly logger: Logger;
    private ormTransform;
    private sql;
    init(): Promise<void>;
    sync(): Promise<void>;
    reflectModels(models: StaticModelT<ModelT<PkType>>[]): void;
    private models;
    private modelsByTableName;
    reflectModel(modelFn: StaticModelT<ModelT<PkType>>): void;
    private reflectAssociations(models);
    private reflectModelAssociations(modelFn);
    private createDbImpls(models);
    private isStaticModelT(test);
    private isTableNameRef(test);
    private isModelNameRef(test);
    private resolveForeignModelFn(meta);
}
